diff -Naur -X diff_ignore rsync-3.0.6_base/syscall.c rsync/syscall.c
--- rsync-3.0.6_base/syscall.c	2009-06-18 17:30:46.000000000 -0400
+++ rsync/syscall.c	2018-12-18 16:48:07.000000000 -0500
@@ -29,6 +29,9 @@
 #include <sys/attr.h>
 #endif
 
+// For dirname()
+#include <libgen.h>
+
 extern int dry_run;
 extern int am_root;
 extern int read_only;
@@ -36,11 +39,8 @@
 extern int force_change;
 extern int preserve_perms;
 extern int preserve_executability;
-
-struct create_time {
-	unsigned long length;
-	struct timespec crtime;
-};
+extern int unsupported_fileflags;
+extern const char *dstRoot;
 
 #define RETURN_ERROR_IF(x,e) \
 	do { \
@@ -59,17 +59,31 @@
 	if (unlink(fname) == 0)
 		return 0;
 #ifdef SUPPORT_FORCE_CHANGE
-	if (force_change && errno == EPERM) {
-		STRUCT_STAT st;
+	if (force_change && (errno == EPERM || errno == EACCES)) {
+		STRUCT_STAT st, pst;
+		char *parent;
+		int became_mutable;
+		int saved_errno = errno;
 
-		if (x_lstat(fname, &st, NULL) == 0
-		 && make_mutable(fname, st.st_mode, st.st_flags, force_change) > 0) {
-			if (unlink(fname) == 0)
+		if (x_lstat(fname, &st, NULL) == 0) {
+			became_mutable = make_mutable(fname, st.st_mode, st.st_flags, force_change) > 0;
+			if (became_mutable && unlink(fname) == 0)
 				return 0;
-			undo_make_mutable(fname, st.st_flags);
+
+			/* Attempt to make the parent directory mutable */
+			if ((parent = dirname((char *)fname)) != NULL
+				&& x_lstat(parent, &pst, NULL) == 0) {
+				if (make_mutable(parent, pst.st_mode, pst.st_flags, force_change) > 0) {
+					if (unlink(fname) == 0) {
+						undo_make_mutable(parent, pst.st_flags);
+						return 0;
+					} else {
+						undo_make_mutable(parent, pst.st_flags);
+					}
+				}
+			}
 		}
-		/* TODO: handle immutable directories */
-		errno = EPERM;
+		errno = saved_errno;
 	}
 #endif
 	return -1;
@@ -77,17 +91,145 @@
 
 int do_symlink(const char *fname1, const char *fname2)
 {
+	int ret;
 	if (dry_run) return 0;
 	RETURN_ERROR_IF_RO_OR_LO;
-	return symlink(fname1, fname2);
+	ret = symlink(fname1, fname2);
+
+#ifdef SUPPORT_FORCE_CHANGE
+	if (force_change && (errno == EPERM || errno == EACCES)) {
+		STRUCT_STAT pst;
+		char *parent;
+		int saved_errno = errno;
+
+		/* Attempt to make the parent directory mutable */
+		if ((parent = dirname((char *)fname2)) != NULL
+				&& x_lstat(parent, &pst, NULL) == 0) {
+			if (make_mutable(parent, pst.st_mode, pst.st_flags, force_change) > 0) {
+				if (symlink(fname1, fname2) == 0) {
+					undo_make_mutable(parent, pst.st_flags);
+					return 0;
+				} else {
+					undo_make_mutable(parent, pst.st_flags);
+				}
+			}
+		}
+		errno = saved_errno;
+	}
+#endif
+
+	return ret;
 }
 
 #ifdef HAVE_LINK
 int do_link(const char *fname1, const char *fname2)
 {
+	int ret;
 	if (dry_run) return 0;
 	RETURN_ERROR_IF_RO_OR_LO;
-	return link(fname1, fname2);
+	ret = link(fname1, fname2);
+
+	if (errno == EPERM) {
+		errno = 0;
+		char fnametmp[MAXPATHLEN];
+		if (!get_tmpname(fnametmp, fname1)) {
+			fprintf(stderr, "DEBUG: Failed to get temporary filename for %s\n", fname1);
+			errno = EPERM;
+		} else {
+			if (!mktemp(fnametmp)) {
+				fprintf(stderr, "DEBUG: mktemp(%s) failed: %d\n", fnametmp, errno);
+				errno = EPERM;
+			} else {
+				ret = link(fname1, fnametmp);
+				if (ret != 0) {
+					fprintf(stderr, "DEBUG: Failed to make temporary hard link at %s: %d\n", fnametmp, errno);
+					if (errno == EPERM) {
+						// Try again, creating the hard link in a folder at the root of the destination
+						char dst_hl_tmp[MAXPATHLEN];
+						pathjoin(dst_hl_tmp, MAXPATHLEN, dstRoot, ".com.bombich.ccc.hl");
+						if (mkdir(dst_hl_tmp, S_IRWXU) != 0) {
+							fprintf(stderr, "DEBUG: Failed to create hard link temp dir at %s: %d\n", dst_hl_tmp, errno);
+							errno = EPERM;
+						} else {
+							char src[MAXPATHLEN], dst[MAXPATHLEN];
+							pathjoin(src, MAXPATHLEN, dst_hl_tmp, "hlink_src");
+							pathjoin(dst, MAXPATHLEN, dst_hl_tmp, "hlink_dst");
+							ret = rename(fname1, src);
+							if (ret != 0) {
+								fprintf(stderr, "DEBUG: Failed to temporarily rename %s -> %s: %d\n", fname1, src, errno);
+								errno = EPERM;
+							} else {
+								ret = link(src, dst);
+								int rename_ret = rename(src, fname1);
+								if (rename_ret != 0)
+									fprintf(stderr, "DEBUG: Failed to rename %s back to %s: %d\n", src, fname1, errno);
+
+								if (ret != 0) {
+									fprintf(stderr, "DEBUG: Failed to make temporary hard link at %s: %d\n", dst, errno);
+									errno = EPERM;
+								} else {
+									ret = rename(dst, fname2);
+									if (ret != 0) {
+										fprintf(stderr, "DEBUG: Failed to rename temporary hard link %s -> %s: %d\n", dst, fname2, errno);
+										unlink(dst);
+										errno = EPERM;
+									}
+								}
+							}
+							if (rmdir(dst_hl_tmp) != 0)
+								fprintf(stderr, "DEBUG: Failed to remove hard link temp dir %s -> %s: %d\n", dst, fname2, errno);
+						}
+					} else {
+						errno = EPERM;
+					}
+				} else {
+					ret = rename(fnametmp, fname2);
+					if (ret != 0) {
+						fprintf(stderr, "DEBUG: Failed to rename temporary hard link %s -> %s: %d\n", fnametmp, fname2, errno);
+						unlink(fnametmp);
+						errno = EPERM;
+					}
+				}
+			}
+		}
+	}
+	
+#ifdef SUPPORT_FORCE_CHANGE
+ 	if (force_change && errno == EACCES) {
+		STRUCT_STAT st, pst;
+		char *parent;
+		int became_mutable;
+		int saved_errno = errno;
+
+		if (x_lstat(fname1, &st, NULL) == 0) {
+			became_mutable = make_mutable(fname1, st.st_mode, st.st_flags, force_change) > 0;
+			if (became_mutable && link(fname1, fname2) == 0) {
+				undo_make_mutable(fname1, st.st_flags);
+				return 0;
+			}
+
+			/* Attempt to make the parent directory mutable */
+			if ((parent = dirname((char *)fname2)) != NULL
+					&& x_lstat(parent, &pst, NULL) == 0) {
+				if (make_mutable(parent, pst.st_mode, pst.st_flags, force_change) > 0) {
+					if (link(fname1, fname2) == 0) {
+						if (became_mutable)
+							undo_make_mutable(fname1, st.st_flags);
+						undo_make_mutable(parent, pst.st_flags);
+						return 0;
+					} else {
+						if (became_mutable)
+							undo_make_mutable(fname1, st.st_flags);
+						undo_make_mutable(parent, pst.st_flags);
+					}
+				}
+			}
+		}
+		errno = saved_errno;
+	}
+#endif
+
+	return ret;
 }
 #endif
 
@@ -101,7 +243,8 @@
 	if (lchown(path, owner, group) == 0)
 		return 0;
 #ifdef SUPPORT_FORCE_CHANGE
-	if (force_change && errno == EPERM) {
+	if (force_change && (errno == EPERM || errno == EACCES)) {
+		int saved_errno = errno;
 		if (fileflags == NO_FFLAGS) {
 			STRUCT_STAT st;
 			if (x_lstat(path, &st, NULL) == 0) {
@@ -116,7 +259,7 @@
 			if (ret == 0)
 				return 0;
 		}
-		errno = EPERM;
+		errno = saved_errno;
 	}
 #else
 	mode = fileflags = 0; /* avoid compiler warning */
@@ -181,16 +324,35 @@
 	if (rmdir(pathname) == 0)
 		return 0;
 #ifdef SUPPORT_FORCE_CHANGE
-	if (force_change && errno == EPERM) {
-		STRUCT_STAT st;
+	if (force_change && (errno == EPERM || errno == EACCES)) {
+		STRUCT_STAT st, pst;
+		char *parent;
+		int became_mutable;
+		int saved_errno = errno;
 
-		if (x_lstat(pathname, &st, NULL) == 0
-		 && make_mutable(pathname, st.st_mode, st.st_flags, force_change) > 0) {
-			if (rmdir(pathname) == 0)
-				return 0;
-			undo_make_mutable(pathname, st.st_flags);
+		if (x_lstat(pathname, &st, NULL) == 0) {
+			became_mutable = make_mutable(pathname, st.st_mode, st.st_flags, force_change);
+			if (became_mutable >= 0) { // even if this item is not immutable, the parent may be
+				if (rmdir(pathname) == 0)
+					return 0;
+				else {
+					// Attempt to make the parent directory mutable
+					if ((parent = dirname((char *)pathname)) != NULL
+							&& x_lstat(parent, &pst, NULL) == 0) {
+						if (make_mutable(parent, pst.st_mode, pst.st_flags, force_change) > 0) {
+							if (rmdir(pathname) == 0) {
+								undo_make_mutable(parent, pst.st_flags);
+								return 0;
+							} else
+								undo_make_mutable(parent, pst.st_flags);
+						}
+					}
+				}
+				if (became_mutable)
+					undo_make_mutable(pathname, st.st_flags);
+			}
 		}
-		errno = EPERM;
+		errno = saved_errno;
 	}
 #endif
 	return -1;
@@ -198,12 +360,19 @@
 
 int do_open(const char *pathname, int flags, mode_t mode)
 {
+	int fd = -1;
+
 	if (flags != O_RDONLY) {
 		RETURN_ERROR_IF(dry_run, 0);
 		RETURN_ERROR_IF_RO_OR_LO;
 	}
+	
+	fd = open(pathname, flags | O_BINARY, mode);
+	
+	if (fd > 0)
+		fcntl(fd, F_NOCACHE, 1);
 
-	return open(pathname, flags | O_BINARY, mode);
+	return fd;
 }
 
 #ifdef HAVE_CHMOD
@@ -229,7 +398,8 @@
 	} else
 		code = chmod(path, mode & CHMOD_BITS); /* DISCOURAGED FUNCTION */
 #ifdef SUPPORT_FORCE_CHANGE
-	if (code < 0 && force_change && errno == EPERM && !S_ISLNK(mode)) {
+	if (code < 0 && force_change && (errno == EPERM || errno == EACCES) /*&& !S_ISLNK(mode)*/) {
+		int saved_errno = errno;
 		if (fileflags == NO_FFLAGS) {
 			STRUCT_STAT st;
 			if (x_lstat(path, &st, NULL) == 0)
@@ -242,7 +412,7 @@
 			if (code == 0)
 				return 0;
 		}
-		errno = EPERM;
+		errno = saved_errno;
 	}
 #else
 	fileflags = 0; /* avoid compiler warning */
@@ -257,8 +427,13 @@
 int do_chflags(const char *path, uint32 fileflags)
 {
 	if (dry_run) return 0;
+	int _ff = fileflags;
 	RETURN_ERROR_IF_RO_OR_LO;
-	return chflags(path, fileflags);
+	if (unsupported_fileflags == ALL_FFLAGS)
+		return 0;
+	if (unsupported_fileflags > 0)
+		_ff &= ~unsupported_fileflags;
+	return lchflags(path, _ff);
 }
 #endif
 
@@ -269,9 +444,14 @@
 	if (rename(fname1, fname2) == 0)
 		return 0;
 #ifdef SUPPORT_FORCE_CHANGE
-	if (force_change && errno == EPERM) {
-		STRUCT_STAT st1, st2;
-		int became_mutable;
+	if (force_change && (errno == EPERM || errno == EACCES)) {
+		STRUCT_STAT st1, st2, pst1, pst2;
+		int became_mutable=0, p1_mutable = 0, p2_mutable = 0;
+		char *dirtmp, p1[MAXPATHLEN], p2[MAXPATHLEN];
+		int saved_errno = errno;
+
+		if (verbose > 1)
+			fprintf(stderr, "do_rename(%s -> %s): calling make_mutable(%s, %d, %d)\n", fname1, fname2, fname1, st1.st_flags, force_change);
 
 		if (x_lstat(fname1, &st1, NULL) != 0)
 			goto failed;
@@ -280,19 +460,58 @@
 			goto success;
 		if (x_lstat(fname2, &st2, NULL) == 0
 		 && make_mutable(fname2, st2.st_mode, st2.st_flags, force_change) > 0) {
-			if (rename(fname1, fname2) == 0) {
-			  success:
-				if (became_mutable) /* Yes, use fname2 and st1! */
-					undo_make_mutable(fname2, st1.st_flags);
-				return 0;
-			}
-			undo_make_mutable(fname2, st2.st_flags);
+			if (rename(fname1, fname2) == 0)
+			  goto success;
 		}
-		/* TODO: handle immutable directories */
-		if (became_mutable)
-			undo_make_mutable(fname1, st1.st_flags);
+
+		// Now try making the parent directories mutable
+		if ((dirtmp = dirname((char *)fname1)) == NULL)
+			goto failed;
+		strncpy(p1, dirtmp, MAXPATHLEN);
+
+		if (x_lstat(p1, &pst1, NULL) != 0)
+			goto failed;
+
+		p1_mutable = make_mutable(p1, pst1.st_mode, pst1.st_flags, force_change) > 0;
+		if (p1_mutable && rename(fname1, fname2) == 0)
+			goto success;
+
+		if ((dirtmp = dirname((char *)fname2)) == NULL)
+			goto failed;
+		strncpy(p2, dirtmp, MAXPATHLEN);
+
+		if (strcmp(p1, p2) != 0) {
+			if (x_lstat(p2, &pst2, NULL) != 0)
+				goto failed;
+
+			p2_mutable = make_mutable(p2, pst2.st_mode, pst2.st_flags, force_change) > 0;
+			if (p2_mutable && rename(fname1, fname2) == 0)
+				goto success;
+
+		}
+		
 	  failed:
-		errno = EPERM;
+		errno = saved_errno;
+		if (became_mutable) {
+			undo_make_mutable(fname1, st1.st_flags);
+			undo_make_mutable(fname2, st2.st_flags);
+		}
+		if (p1_mutable)
+			undo_make_mutable(p1, pst1.st_flags);
+		if (p2_mutable)
+			undo_make_mutable(p2, pst2.st_flags);
+		return -1;
+		
+	  success:
+		if (became_mutable) /* Yes, use fname2 and st1! */
+			undo_make_mutable(fname2, st1.st_flags);
+		if (p1_mutable)
+			undo_make_mutable(p1, pst1.st_flags);
+		if (p2_mutable)
+			undo_make_mutable(p2, pst2.st_flags);
+		return 0;
+		
+		
 	}
 #endif
 	return -1;
@@ -318,10 +537,34 @@
 
 int do_mkdir(char *fname, mode_t mode)
 {
+	int ret;
 	if (dry_run) return 0;
 	RETURN_ERROR_IF_RO_OR_LO;
 	trim_trailing_slashes(fname);
-	return mkdir(fname, mode);
+	ret = mkdir(fname, mode);
+
+#ifdef SUPPORT_FORCE_CHANGE
+	if (force_change && (errno == EPERM || errno == EACCES)) {
+		STRUCT_STAT pst;
+		char *parent;
+		int saved_errno = errno;
+
+		// Attempt to make the parent directory mutable
+		if ((parent = (char *)dirname(fname)) != NULL
+				&& x_lstat(parent, &pst, NULL) == 0) {
+			if (make_mutable(parent, pst.st_mode, pst.st_flags, force_change) > 0) {
+				if (mkdir(fname, mode) == 0) {
+					undo_make_mutable(parent, pst.st_flags);
+					return 0;
+				} else
+					undo_make_mutable(parent, pst.st_flags);
+			}
+		}
+		errno = saved_errno;
+	}
+#endif
+
+	return ret;
 }
 
 /* like mkstemp but forces permissions */
@@ -336,7 +579,10 @@
 		int fd = mkstemp(template);
 		if (fd == -1)
 			return -1;
-		if (fchmod(fd, perms) != 0 && preserve_perms) {
+		// Network filesystems may return EACCES if you try to remove group privileges
+		// We don't want to avoid limiting initial access permissions, but
+		// that particular failure should not be grounds for avoiding the copy
+		if (fchmod(fd, perms) != 0 && preserve_perms && errno != EACCES) {
 			int errno_save = errno;
 			close(fd);
 			unlink(template);
@@ -402,7 +648,8 @@
 
 time_t get_create_time(const char *path)
 {
-	static struct create_time attrBuf;
+	static char attrBuf[sizeof(u_int32_t) + sizeof(struct timespec)];
+	static struct timespec  *crtime = (struct timespec*)&attrBuf[sizeof(u_int32_t)];
 	struct attrlist attrList;
 
 	memset(&attrList, 0, sizeof attrList);
@@ -410,7 +657,7 @@
 	attrList.commonattr = ATTR_CMN_CRTIME;
 	if (getattrlist(path, &attrList, &attrBuf, sizeof attrBuf, FSOPT_NOFOLLOW) < 0)
 		return 0;
-	return attrBuf.crtime.tv_sec;
+	return crtime->tv_sec;
 }
 
 int set_create_time(const char *path, time_t crtime)
diff -Naur -X diff_ignore rsync-3.0.6_base/token.c rsync/token.c
--- rsync-3.0.6_base/token.c	2009-01-17 16:41:35.000000000 -0500
+++ rsync/token.c	2019-01-14 13:37:29.000000000 -0500
@@ -193,6 +193,8 @@
 		return;
 
 	while (1) {
+		if (isUpper(&ltr))
+			ltr = toLower(&ltr);
 		while (node->letter != ltr) {
 			if (node->letter > ltr)
 				return;
@@ -244,8 +246,17 @@
 		int32 len = 0;
 		while (len < n) {
 			int32 n1 = MIN(CHUNK_SIZE, n-len);
+			char *window = map_ptr(buf, offset+len, n1);
+			if (buf->status != 0) {
+				// BOMBICH
+				// Rather than sending an empty buffer when we have read errors, send the "finished" token and exit
+				// This specifically allows us to skip past the broken file and attempt to copy the remaining files
+				write_int(f, 0);
+				return;
+			}
+
 			write_int(f, n1);
-			write_buf(f, map_ptr(buf, offset+len, n1), n1);
+			write_buf(f, window, n1);
 			len += n1;
 		}
 	}
@@ -349,8 +360,7 @@
 			if (tx_strm.avail_in == 0 && nb != 0) {
 				/* give it some more input */
 				n = MIN(nb, CHUNK_SIZE);
-				tx_strm.next_in = (Bytef *)
-					map_ptr(buf, offset, n);
+				tx_strm.next_in = (Bytef *)map_ptr(buf, offset, n);
 				tx_strm.avail_in = n;
 				nb -= n;
 				offset += n;
@@ -599,7 +609,7 @@
 		rx_strm.next_out = (Bytef *)dbuf;
 		rx_strm.avail_out = AVAIL_OUT_SIZE(CHUNK_SIZE);
 		r = inflate(&rx_strm, Z_SYNC_FLUSH);
-		if (r != Z_OK) {
+		if (r != Z_OK && r != Z_BUF_ERROR) {
 			rprintf(FERROR, "inflate (token) returned %d\n", r);
 			exit_cleanup(RERR_STREAMIO);
 		}
@@ -611,8 +621,7 @@
  * If token == -1 then we have reached EOF
  * If n == 0 then don't send a buffer
  */
-void send_token(int f, int32 token, struct map_struct *buf, OFF_T offset,
-		int32 n, int32 toklen)
+void send_token(int f, int32 token, struct map_struct *buf, OFF_T offset, int32 n, int32 toklen)
 {
 	if (!do_compression)
 		simple_send_token(f, token, buf, offset, n);
diff -Naur -X diff_ignore rsync-3.0.6_base/util.c rsync/util.c
--- rsync-3.0.6_base/util.c	2009-06-18 17:30:42.000000000 -0400
+++ rsync/util.c	2019-01-14 17:36:11.000000000 -0500
@@ -36,6 +36,8 @@
 extern mode_t orig_umask;
 extern char *partial_dir;
 extern struct filter_list_struct daemon_filter_list;
+extern int io_buf_size;
+extern int checksum_len;
 
 int sanitize_paths = 0;
 
@@ -43,6 +45,20 @@
 unsigned int curr_dir_len;
 int curr_dir_depth; /* This is only set for a sanitizing daemon. */
 
+static time_t last_hb = 0;
+void heartbeat(char *fbuf)
+{
+	if (last_hb == 0)
+		last_hb = time(NULL);
+	time_t now = time(NULL);
+	if (now - last_hb > 5) {
+		last_hb = now;
+		rprintf(FINFO, "S;;;HRTBT;;;CF;;;%s\n", fbuf);
+	}
+}
+
+
+
 /* Set a fd into nonblocking mode. */
 void set_nonblocking(int fd)
 {
@@ -78,9 +94,17 @@
 int fd_pair(int fd[2])
 {
 	int ret;
+	int bufsize;
 
 #ifdef HAVE_SOCKETPAIR
 	ret = socketpair(AF_UNIX, SOCK_STREAM, 0, fd);
+	bufsize = io_buf_size;
+	fprintf(stderr, "DEBUG: [%s] Setting IO buffer size to %d\n", who_am_i(), io_buf_size);
+	setsockopt(fd[0], SOL_SOCKET, SO_SNDBUF, &bufsize, sizeof(bufsize));
+	setsockopt(fd[0], SOL_SOCKET, SO_RCVBUF, &bufsize, sizeof(bufsize));
+	setsockopt(fd[1], SOL_SOCKET, SO_SNDBUF, &bufsize, sizeof(bufsize));
+	setsockopt(fd[1], SOL_SOCKET, SO_RCVBUF, &bufsize, sizeof(bufsize));
+
 #else
 	ret = pipe(fd);
 #endif
@@ -297,10 +321,10 @@
 	int ifd;
 	char buf[1024 * 8];
 	int len;   /* Number of bytes read into `buf'. */
-
+	
 	if ((ifd = do_open(source, O_RDONLY, 0)) < 0) {
 		int save_errno = errno;
-		rsyserr(FERROR_XFER, errno, "open %s", full_fname(source));
+		rsyserr(FERROR_XFER, errno, "copy_file: open %s", full_fname(source));
 		errno = save_errno;
 		return -1;
 	}
@@ -308,13 +332,15 @@
 	if (ofd < 0) {
 		if (robust_unlink(dest) && errno != ENOENT) {
 			int save_errno = errno;
-			rsyserr(FERROR_XFER, errno, "unlink %s", full_fname(dest));
+			rsyserr(FERROR_XFER, errno, "copy_file: unlink %s", full_fname(dest));
 			errno = save_errno;
 			return -1;
 		}
 
 		if ((ofd = do_open(dest, O_WRONLY | O_CREAT | O_TRUNC | O_EXCL, mode)) < 0) {
 			int save_errno = errno ? errno : EINVAL; /* 0 paranoia */
+			if (verbose)
+				fprintf(stderr, "DEBUG: copy_file: do_open(%s) failed: %d%s\n", dest, errno, create_bak_dir ? ". Calling make_bak_dir()" : "");
 			if (create_bak_dir && errno == ENOENT && make_bak_dir(dest) == 0) {
 				if ((ofd = do_open(dest, O_WRONLY | O_CREAT | O_TRUNC | O_EXCL, mode)) < 0)
 					save_errno = errno ? errno : save_errno;
@@ -322,7 +348,7 @@
 					save_errno = 0;
 			}
 			if (save_errno) {
-				rsyserr(FERROR_XFER, save_errno, "open %s", full_fname(dest));
+				rsyserr(FERROR_XFER, save_errno, "copy_file: open %s", full_fname(dest));
 				close(ifd);
 				errno = save_errno;
 				return -1;
@@ -333,17 +359,18 @@
 	while ((len = safe_read(ifd, buf, sizeof buf)) > 0) {
 		if (full_write(ofd, buf, len) < 0) {
 			int save_errno = errno;
-			rsyserr(FERROR_XFER, errno, "write %s", full_fname(dest));
+			rsyserr(FERROR_XFER, errno, "copy_file: write %s", full_fname(dest));
 			close(ifd);
 			close(ofd);
 			errno = save_errno;
 			return -1;
 		}
+		heartbeat((char *)source);
 	}
 
 	if (len < 0) {
 		int save_errno = errno;
-		rsyserr(FERROR_XFER, errno, "read %s", full_fname(source));
+		rsyserr(FERROR_XFER, errno, "copy_file: read %s", full_fname(source));
 		close(ifd);
 		close(ofd);
 		errno = save_errno;
@@ -351,13 +378,13 @@
 	}
 
 	if (close(ifd) < 0) {
-		rsyserr(FWARNING, errno, "close failed on %s",
+		rsyserr(FWARNING, errno, "copy_file: close failed on %s",
 			full_fname(source));
 	}
 
 	if (close(ofd) < 0) {
 		int save_errno = errno;
-		rsyserr(FERROR_XFER, errno, "close failed on %s",
+		rsyserr(FERROR_XFER, errno, "copy_file: close failed on %s",
 			full_fname(dest));
 		errno = save_errno;
 		return -1;
@@ -1356,6 +1383,9 @@
  **/
 int msleep(int t)
 {
+#ifdef HAVE_USLEEP
+       usleep(t*1000);
+#else
 	int tdiff = 0;
 	struct timeval tval, t1, t2;
 
@@ -1371,8 +1401,10 @@
 		gettimeofday(&t2, NULL);
 		tdiff = (t2.tv_sec - t1.tv_sec)*1000 +
 			(t2.tv_usec - t1.tv_usec)/1000;
+		if (tdiff < 0)
+			t1 = t2; /* Time went backwards, so start over. */
 	}
-
+#endif
 	return True;
 }
 
@@ -1703,11 +1735,30 @@
 				who_am_i(), desc, (double)new_size * item_size,
 				new_ptr == lp->items ? " not" : "");
 		}
-		if (!new_ptr)
+		if (!new_ptr) {
+			fprintf(stderr, "DEBUG: Out of memory in expand_item_list(%s). Current count: %lu\n", desc, lp->count);
 			out_of_memory("expand_item_list");
+		}
 
 		lp->items = new_ptr;
 		lp->malloced = new_size;
 	}
 	return (char*)lp->items + (lp->count++ * item_size);
 }
+
+char * printableChecksum(char *sum)
+{
+	int i, x1, x2;
+	char *c = malloc(checksum_len*2+1);
+	for (i = 0; i < checksum_len; i++) {
+		x1 = CVAL(sum, i);
+		x2 = x1 >> 4;
+		x1 &= 0xF;
+		c[i*2] = x2 <= 9 ? x2 + '0' : x2 + 'a' - 10;
+		c[i*2+1] = x1 <= 9 ? x1 + '0' : x1 + 'a' - 10;
+	}
+	c[checksum_len*2] = '\0';
+	
+	return c;
+}
+
